          CPU  "8048.TBL"               ; CPU TABLE
          HOF  "INT8"                   ; HEX FORMAT
                                        ; MODULE NAME-------------MAIN MODULE.
                                        ; MODULE NUMBER-----------DACT0006
                                        ; VERSION-----------------1
                                        ; SHEET NAME--------------DACT1006
                                        ; SOFTWARE----------------MCS-48
                                        ; ASSEMBLER---------------CROSS 16
                                        ; HARDWARE----------------DACT0006.SCH
                                        ; DESCRIPTION-------------MOTHER CODE
                                        ; DEVELOPED BY------------Anantha Narayan
                                        ; COMPANY-----------------DE Laboratories.
                                        ; DATE--------------------9th September 1999
                                        ; SYSTEM CONFIGURATION.
INCL0:    INCL "EQUAT.ASM"              ; INLUDE "EQUAT" MODULE HERE.
                                        ; MAIN TREE BRANCHES.
          ORG 000H                      ; ON RESET AT 0000 ADDR.
          JMP START                     ; JUMP TO START ROUTINE.
          ORG 003H                      ; ON EXINT AT 0007 ADDR.
          JMP EXINT                     ; JUMP TO EXINT ROUTINE.
                                        ; MAIN START BRANCH
          ORG 010H                      ;
START:    DIS I                         ; DISABLE EXTERNAL INT.
          DIS TCNTI                     ; DISABLE TIMER/COUNTER INT.
          ORL P1,#0F0H                  ; ENABLE KEYS AT P1 AND TURN OFF DISPLAY.
          ORL P2,#0FFH                  ; TURN OFF RELAYS AND OUTPUTS.
          IN A,P1                       ; MOVE INTO ACC VALUE AT P1
          CPL A                         ; INVERT DATA IN ACC.
          ANL A,#IOMSK                  ; F0H MAKES LOWER NIBBLE OF ACC 0000
          XRL A,#11110000B              ; IF ALL KEYS ARE PRESSED THEN ALL RAM=0.
          JZ CHKT0                      ; TEST IF T0 IS HIGH.
          JMP CLRNR                     ; IF ALL KEYS NOT PRESSED CLEAR 0-30 RAM ONLY.
CHKT0:    JT0 CLRNR                     ; JUMPOVER AS CAL JUMPER ABSENT.
          MOV R1,#127                   ; IF T0 IS PULLED LOW ALL RAM=0
          MOV R0,#02                    ; CLEAR RAM ALL TO 00H 0 TO 31
ZEROQ:    MOV @R0,#00H                  ; MOVE DATA 00H TO DATA MEM. INT. RAM ADDR. BY R0.
          INC R0                        ; INC RUNS 7D TIMES TILL DJNZ COMMAND MAKES R1=0
          DJNZ R1,ZEROQ                 ; DECREMENT AND CHECK R1 FOR ZERO IF NOT JUMP ZEROZ.
          MOV R1,#HICAL                 ; SET DEFAULTS FOR TICKS AND GATER.
          MOV @R1,#TRATE                ; TRATE DEFAULT FOR TICKS
          MOV R1,#HICUL                 ; GATRAT DEFAULT FOR GATRAT
          MOV @R1,#GATRT                ; TOTAL RESET ALL RAM 00
          JMP CLRAL                     ; JUMPOVER AS CAL JUMPER PRESENT.
CLRNR:    MOV R1,#31                    ; SET R1 TO 31 VALUE WITH R0 & R1 INCLUDED.
          MOV R0,#02                    ; CLEAR RAM ALL TO 00H 0 TO 31
ZEROZ:    MOV @R0,#00H                  ; MOVE DATA 00H TO DATA MEM. INT. RAM ADDR. BY R0.
          INC R0                        ; INC RUNS 7D TIMES TILL DJNZ COMMAND MAKES R1=0
          DJNZ R1,ZEROZ                 ; DECREMENT AND CHECK R1 FOR ZERO IF NOT JUMP ZEROZ.
CLRAL:    CLR F0                        ; CLEAR FLAG 0 JUST A PRECAUTION.
          SEL RB1                       ; SELECT REGISTER BANK 1 USED IN INT.
          MOV R7,#DSPNO                 ; DSPNO 5 IS PLACED IN R7 AS TCINT REQUIRES IT
          SEL RB0                       ; SELECT REGISTER BANK 0.
          CALL CLEAR                    ; CALL CLEAR SUBROUTINE.
          CLR F1                        ; CLEAR FLAG 1.
          CPL F1                        ; SO IT CAN BE PRIMED IN REDSP FIRST TIME.
          STOP TCNT                     ; STOP COUNTING PULSES FROM LM331.
          CLR A                         ; SET ACC TO ZERO.
          MOV T,A                       ; PRESET COUNTER TO 0.
          MOV R1,#LNGTM                 ; SET R1 TO LNGTM LOC. THIS IS TO BRING BACK TO NORMAL.
          MOV @R1,#LRATE                ; SET LONG TIMER TO 300MS*30 9SECONDS.
          MOV R0,#PRGRN                 ; MOVE 107 ADDR FOR PROG/RUN MODE INTO R0.
          MOV @R0,#0                    ; RUN MODE SELECTED BY LOADING 0 .
          MOV R1,#CALRN                 ; SET CALRN 0 AS CALIBRATION IS OVER.
          MOV @R1,#0                    ; CAL MODE TURNED OFF AFTER 10 SECONDS IF NO KEY PRSS.
          MOV R1,#DISPL                 ; SET DISPL TO 0.
          MOV @R1,#0                    ; DISPL SET TO 0 PV SO AFTER ANY SELECTION AUTO PV 10S.
          MOV R0,#TIMES                 ; MOVE 102 ADDR FOR DELAY INTO R0.
          MOV @R0,#SRATE                ; RESET TIMER BY RELOADING 5 KEY SAMPLE RATE 30MS.
          MOV R0,#KEYRT                 ; MOVE 108 ADDR FOR NO OF TIMES PRESS VERIFIED.
          MOV @R0,#BOUNC                ; SET KEY RATE TO 5.
          MOV R0,#RAMPS                 ; MOV R0 TO 111 RAMP DEFAULT OR MAX POSITION.
          MOV @R0,#FASTS                ; LOAD SLOWEST KEY RESP OF 20.
          MOV R0,#RELAY                 ; SET R0 TO CNTRL DELAY LOACATION 35.
          MOV @R0,#RLYRT                ; RELOAD TIMER.
          MOV R1,#FLAG2                 ; SET R1 TO FLAG2 WHICH IS 0 TO PREVENT COUNTS.
          MOV @R1,#0                    ; SET FLAG2=0 TO PREVENT COUNT ON POWER JITTERS.
          MOV R0,#TEMKY                 ; R0 SET TO 112 LOC OF TEMP KEY PRESS.
          MOV @R0,#0                    ; SET IT 0 POWER FAIL PRECAUTION.
          MOV R3,#0                     ; NO KEY PRESS IN RAM.
          MOV R0,#BLINK                 ; BLINK OFF ON POWER ON.
          MOV @R0,#0                    ; SET IT 0 POWER FAIL PRECAUTION.
          ANL P2,#11011111B             ; 4040 RESET TURNED LOW TO ENABLE 4040.
          CALL LNGRT                    ; CALL LNGRT TO SET SPDB AND ALARM.
          EN I                          ; ENABLE EXTERNAL INT.
                                        ; ILOOP MONITOR
ILOOP:                                  ; THIS IS THE MAIN LOOP RUNNING ENDLESSLY WAITING.
                                        ;
INCL1:    INCL "ILOOP.ASM"              ; INCLUDE "ILOOP" MODULE HERE.
                                        ;
          JMP ILOOP                     ; LOOP INDEFINITELY.
                                        ;
ENSGM:    ANL A,#SEGCD                  ; DECODE 0-F 4BIT VALUE TO 7SEGMENT 8BIT CODE.
          ADD A,#CODES                  ; SEGCD MASK IS 0FH AND LOGIC ZEROS UPPER NIBBLE.
          MOVP3 A,@A                    ; ADD TO ACC VALUE IN CODES EQU.
          RET                           ; MOVE INTO ACC ADDR. BY ACC.PROGRAM MEM.
                                        ;
CLEAR:    MOV A,#BLANK XOR SKORA        ; CLEAR SUBROUTINE ENTERS BLANK CODE IN DISPLAY MAP.
DUMPS:    MOV R1,#DSPMP + 2             ; MOVE INTO R1 FIRST LOCATION OF DSPMP 63-DSPNO+2
          MOV R7,#DSPNO                 ; NEXT DIGIT REG R7 IS SET TO DSPNO
CLEAN:    MOV @R1,A                     ; WRITE TO INTERNAL RAM AT 00H BLANK FFH IF SKORA FF.
          INC R1                        ; SELECT NEXT INT RAM LOC.
          DJNZ R7,CLEAN                 ; LOOP TO CLEAN TILL DGNXT IS 0.
          MOV R7,#DSPNO                 ; RESET R7 TO NO OF DIGITS.
          RET                           ; RETURN TO MAIN START.
                                        ;
                                        ; ROUTINES AND TABLES
                                        ;
          ORG 0100H                     ;
INCL2:    INCL "SUBRT.ASM"              ; INCLUDE "SUBRT" MODULE HERE.
          ORG 0200H                     ;
INCL3:    INCL "LNGRT.ASM"              ; INCLUDE "LNGRT" MODULE HERE.
          ORG 0300H                     ;
INCL4:    INCL "TABLE.ASM"              ; INCLUDE "TABLE" MODULE HERE.

                                        ; MAIN EXINT BRANCH
          ORG 03A0H                     ;
EXINT:    SEL RB1                       ; SELECT REGISTER BANK 1,
          MOV R2,A                      ; SAVE DATA IN ACC TO R2,
          MOV A,#11110000B XOR DKORA    ; DISPLAY DRIVE ROUTINE.
          OUTL P1,A                     ; ENABLE DIGIT CATHODE OR ANODE TO 0 DGT UNUSED.
                                        ;
INCL5:    INCL "TCEXT.ASM"              ; INCLUDE "TCEXT" MODULE HERE.
                                        ;
ONJOB:    MOV A,#DSPMP                  ; GET DSPMP ADDR NUMBER 63-5=58 RAM .
          ADD A,R7                      ; ADD THE CURRENT DIGIT IN R7 TO ACC.
          MOV R1,A                      ; PUT ACC VALUE IN R1.
          MOV A,@R1                     ; GET SEG DATA FROM RAM 58-62
          MOVX @R1,A                    ; TURN ON SEGMENT AS IN RAM DATA.
          MOV A,#ENDGT                  ; GET LOCATION IN PROG MEM OF DIGIT CODE.
          ADD A,R7                      ; GET DRIVE CODE FOR THE NXT DIGIT TO TURN ON.
          MOVP3 A,@A                    ; GET FROM PROG MEM TO ACC @ BY ACC. GET CODE.
          OUTL P1,A                     ; ENABLE DIGIT CATHODE OR ANODE COMMON.(TURN KEYS HI)
          DJNZ R7,ERETR                 ; DEC R7 IF NOT Z GO TO TRETR AND HENCE MAIN PROG.
          MOV R7,#DSPNO                 ; IF R7 IS 0 PROG COMES HERE IT IS RELODED WITH 5.
                                        ;
INCL6:    INCL "TIMER.ASM"              ; INCLUDE "TIMER" MODULE HERE.
                                        ;
ERETR:    MOV A,R2                      ; SELECT REGISTER BANK 0 AS A PRECAUTION.
          SEL RB0                       ; ACC RESTORED FROM R2.
          RETR                          ; RETURNS AFTER TIMER INT. IS SERVICED.
                                        ; OTHER MODULES
          ORG 0400H                     ;
INCL7:    INCL "MATHS.ASM"              ; INCLUDE "MATHS" MODULE HERE.
          ORG 0500H                     ;
INCL8:    INCL "CNTRL.ASM"              ; INCLUDE "CNTRL" MODULE HERE.
          ORG 0600H                     ;
INCL9:    INCL "OUTIN.ASM"              ; INCLUDE "OUTIN" MODULE HERE.
          ORG 0700H                     ;
INCL10:   INCL "INOUT.ASM"              ; INCLUDE "INOUT" MODULE HERE.
          END                           ; END OF PROGRAM.
